(function() {
  var allMessages, client, currentEmail, loadMessage, loadMessageBody, messageCount;
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  client = new Faye.Client("http://127.0.0.1:1080/kyatchi");
  allMessages = [];
  messageCount = 0;
  currentEmail = client.subscribe('/current_email', function(message) {
    allMessages.push(message);
    messageCount += 1;
    return $('#messages tbody').append($('<tr />').attr('data-message-id', messageCount).append($('<td/>').text(message.from)).append($('<td/>').text(message.to)).append($('<td/>').text(message.subject)).append($('<td/>').text(message.created_at)));
  });
  $('#messages tr').live('click', __bind(function(e) {
    var id;
    id = $(e.currentTarget).attr('data-message-id');
    $('.download form input[name*="message-id"]').val(id);
    $('.download form').attr('action', "/download/" + id);
    $('.download form input[name*="email"]').val(allMessages[id - 1].content.source);
    return loadMessage($(e.currentTarget).attr('data-message-id'));
  }, this));
  $('#message .views .tab').live('click', __bind(function(e) {
    return loadMessageBody($('#messages tr.selected').attr('data-message-id'), $(e.currentTarget).attr('data-message-format'));
  }, this));
  $('#message .download a').live('click', __bind(function(e) {
    return $('.download form').submit();
  }, this));
  $('nav.app .clear a').live('click', __bind(function(e) {
    if (confirm("You will lose all your received messages.\n\nAre you sure you want to clear all messages?")) {
      allMessages = [];
      messageCount = 0;
      $('#messages tbody').empty();
      $('#message .metadata dd').empty();
      return $('#message div.body').empty();
    }
  }, this));
  loadMessage = function(id) {
    var selectedId, selectedIndex;
    selectedId = id;
    selectedIndex = selectedId - 1;
    $('#messages tbody tr:not([data-message-id="' + selectedId + '"])').removeClass('selected');
    $('#messages tbody tr[data-message-id="' + selectedId + '"]').addClass('selected');
    $('#message .metadata dd.created_at').text(allMessages[selectedIndex].created_at);
    $('#message .metadata dd.from').text(allMessages[selectedIndex].from);
    $('#message .metadata dd.to').text(allMessages[selectedIndex].to);
    $('#message .metadata dd.subject').text(allMessages[selectedIndex].subject);
    if ($("#message .views .tab.selected:not(:visible)").length) {
      $("#message .views .tab.selected").removeClass("selected");
      $("#message .views .tab:visible:first").addClass("selected");
    }
    return loadMessageBody();
  };
  loadMessageBody = function(id, format) {
    var content, selectedIndex;
    id || (id = $('#messages tr.selected').attr('data-message-id'));
    format || (format = $('#message .views .tab.format.selected').attr('data-message-format'));
    format || (format = 'html');
    $("#message .views .tab[data-message-format=" + format + "]:not(.selected)").addClass('selected');
    $("#message .views .tab:not([data-message-format=" + format + "]).selected").removeClass('selected');
    selectedIndex = id - 1;
    if (id != null) {
      content = $(allMessages[selectedIndex].content[format]);
      if (format !== 'html') {
        content = allMessages[selectedIndex].content[format];
      }
      return $('#message div.body').html(content);
    }
  };
}).call(this);
